#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# Jussi Määttä, 2014

# Decode binary input using a given codebook.
#
# Usage:
#
#     decode.py codebook.json < input > output
#
# where codebook.json contains the output of build_codebook.py.

import json
import sys

codebook = json.loads(open(sys.argv[1]).read())
codebook = { value: key for (key, value) in codebook.items() }

codeword = ''
for bit in sys.stdin.read():
    codeword = codeword + bit
    char = codebook.get(codeword)
    if char != None:
        sys.stdout.write(char)
        codeword = ''

if codeword != '':
    raise RuntimeError('Broken input')