#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# Jussi Määttä, 2014

# Encode input stream using a given codebook.
#
# Usage:
#
#     encode.py codebook.json < input > output
#
# where codebook.json contains the output of build_codebook.py.

import json
import sys

codebook = json.loads(open(sys.argv[1]).read())
for c in sys.stdin.read():
    if c in codebook:
        sys.stdout.write(codebook[c])
    else:
        raise RuntimeError('Unknown character: ' + c)