/* Output 1024 bytes that do not compress well using gzip.
 *
 * The program uses the sequence
 *
 *    x(1)   = 0.3,
 *    x(n+1) = x * (1.0 - x),    (for n >= 1),
 *
 * which is a variation of the so-called "logistic map"
 * (see e.g. <http://mathworld.wolfram.com/LogisticMap.html>).
 *
 * The output has the desired property on little-endian systems
 * with a four-byte int and IEEE 754 floats.
 *
 * Jussi Maatta 2014
 */

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
    int i;
    float x = 0.3;
    int *y = (int *)(&x);

    for (i = 0; i < 1024; i++)
    {
        x = 3.9 * x * (1.0 - x);
        putchar(*y);
    }

    return EXIT_SUCCESS;
}
